unit UMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ScktComp, Buttons, ComCtrls;

type
  TfrmMain = class(TForm)
    cs: TClientSocket;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    edtHostName: TEdit;
    lbOpenPortList: TListBox;
    btnScan: TBitBtn;
    btnCancel: TBitBtn;
    sbStat: TStatusBar;
    procedure btnScanClick(Sender: TObject);
    procedure csConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure csError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnCancelClick(Sender: TObject);
  private
    procedure SetHostSettings;
    { Private declarations }
  public
    { Public declarations }
  end;


var
  frmMain: TfrmMain;

implementation

{$R *.dfm}
var
  HostName: string;
  PortNo: Integer;
  Working: Boolean;

procedure TfrmMain.SetHostSettings;
begin
  if not(Working) then exit;
  sbStat.SimpleText := IntToStr(PortNo) + '. port is testing...';
  cs.Host := HostName;
  cs.Port := PortNo;
  cs.Active := true;
end;

procedure TfrmMain.btnScanClick(Sender: TObject);
begin
  if(Working) then exit;

  Working := true;
  lbOpenPortList.Clear;
  HostName := edtHostName.Text;
  PortNo := 0;
  SetHostSettings;
end;

procedure TfrmMain.csConnect(Sender: TObject; Socket: TCustomWinSocket);
begin
  cs.Active := false;
  lbOpenPortList.Items.Add(IntToStr(PortNo) + '. port is open');
  Inc(PortNo);
  SetHostSettings;
end;

procedure TfrmMain.csError(Sender: TObject; Socket: TCustomWinSocket;
  ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
  ErrorCode := 0;
  cs.Active := false;
  Inc(PortNo);
  SetHostSettings;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  cs.Active := false;
end;

procedure TfrmMain.btnCancelClick(Sender: TObject);
begin
  Working := false;
end;

end.
